package channel

import kotlin.reflect.KType

class CommandDescriptor<I, A, R>(
    val name: String,
    val ass: KType,
    val rss: KType,
) {
    suspend operator fun invoke(adapter: Adapter<I>, args: A): R =
        adapter.invokeCommand(this, args)

    @Suppress("UNCHECKED_CAST")
    suspend operator fun invoke(adapter: Adapter<I>): R = adapter.invokeCommand(this,Unit as A)

    operator fun invoke(commandHost: CommandHost<I>, block: suspend I.(A)->R) {
        commandHost.on(this, block)
    }
}

