package net.sergeych.cloudoc.api

enum class ApiError {
    UNKNOWN_ERROR,
    INTERNAL_ERROR,
    BAD_RESPONSE_PACKAGE,
    NOT_FOUND,
    BAD_LOGIN,
    OBJECT_ALREADY_EXISTS,
    ACCESS_FORBIDDEN,
    ILLEGAL_STATE,
    NOT_LOGGED_IN,
    BAD_PARAMETER,
    EMAIL_IN_USE,
    NAME_IN_USE;

    fun raise(text: String? = null): Nothing {
        throw ApiException(this, text ?: defaultText())
    }

    fun defaultText(): String = name.lowercase().replace('_', ' ')
}

class ApiException(val code: ApiError, _text: String? = null, cause: Throwable? = null):
Exception(_text ?: code.defaultText(), cause) {
    val text by lazy { _text ?: code.defaultText() }
}
